<script setup lang="ts">
import AppButton from '@/components/ui/AppButton.vue'
import { client } from '@/scripts/api-helper'
import { useAppStore } from '@/stores/app'
import { onMounted, reactive } from 'vue'

const app = useAppStore()

const state = reactive({
  formOpen: null as boolean | null
})

async function checkFormOpen() {
  const { error, data } = await client.GET('/api/login/form-open', {})
  if (error != null) {
    console.error(error)
  } else {
    state.formOpen = data
  }
}

async function loginWithTequila() {
  const redirectionUrl = await app.tequilaRequest()
  if (redirectionUrl != null) {
    window.location.href = redirectionUrl
  }
}

onMounted(() => {
  checkFormOpen()
})
</script>

<template>
  <main>
    <section class="bg-white dark:bg-gray-900">
      <div
        class="gap-8 items-center py-8 px-4 mx-auto max-w-screen-xl xl:gap-16 md:grid md:grid-cols-2 sm:py-16 lg:px-6"
      >
        <img class="w-full" src="@/assets/yearbooks.png" alt="Many yearbooks" />
        <div class="mt-4 md:mt-0">
          <h2
            class="mb-4 text-2xl md:text-4xl tracking-tight font-extrabold text-gray-900 dark:text-white"
          >
            {{ $t('home.headline') }}
          </h2>
          <p class="mb-6 font-light text-gray-500 md:text-lg dark:text-gray-400">
            {{ $t('home.description') }}
          </p>

          <div v-if="state.formOpen === null"></div>
          <div v-else-if="!state.formOpen">
            <div
              class="flex items-center p-4 mb-4 text-sm text-red-800 border border-red-300 rounded-lg bg-red-50 dark:bg-gray-800 dark:text-red-400 dark:border-red-800"
              role="alert"
            >
              <svg
                class="flex-shrink-0 inline w-4 h-4 me-3"
                aria-hidden="true"
                xmlns="http://www.w3.org/2000/svg"
                fill="currentColor"
                viewBox="0 0 20 20"
              >
                <path
                  d="M10 .5a9.5 9.5 0 1 0 9.5 9.5A9.51 9.51 0 0 0 10 .5ZM9.5 4a1.5 1.5 0 1 1 0 3 1.5 1.5 0 0 1 0-3ZM12 15H8a1 1 0 0 1 0-2h1v-3H8a1 1 0 0 1 0-2h2a1 1 0 0 1 1 1v4h1a1 1 0 0 1 0 2Z"
                />
              </svg>
              <div>{{ $t('home.formClosedAlert') }}</div>
            </div>
          </div>
          <div v-else-if="!app.isSessionActive" class="flex items-center space-x-3">
            <AppButton @click="loginWithTequila" variant="outlined">
              {{ $t('home.loginWithTequila') }}
            </AppButton>

            <RouterLink to="/email-login">
              <AppButton variant="text-faint">
                {{ $t('home.emailLogin') }}
              </AppButton>
            </RouterLink>
          </div>
          <div v-else>
            <RouterLink to="/home">
              <AppButton>
                {{ $t('home.myAccount') }}
              </AppButton>
            </RouterLink>
          </div>
        </div>
      </div>
    </section>
  </main>
</template>
